
// Byte Sieve - Integer version

GET "libhdr.h"
GET "sys.h"

MANIFEST
{
  size = 4095
}

LET start () = VALOF
{
  LET flags = getvec (size + 1)
  LET tStart, tEnd = ?,?
  LET count = 0

  writes ("Starting*n")
  UNLESS flags THEN
  {
    writes ("Out of memory*n")
    RESULTIS 1
  }

  tStart := sys (Sys_cputime)

  FOR i = 0 TO size DO
    flags!i := TRUE

  FOR i = 0 TO size DO
  {
    LET prime, k = ?, ?

    IF flags!i THEN
    {

      prime := i + i + 3
      k     := i + prime
      WHILE k <= size DO
      {
	flags!k := FALSE
	k := k + prime
      }
      count := count + 1
    }
  }

  tEnd := sys (Sys_cputime)

  writef ("Time: %d ms*n", tEnd - tStart)
  writef ("  %d  primes found.*n", count)

  freevec (flags)

  RESULTIS 0
}
