// Noels Retro Lab Benchmark.
//    Translated from BASIC to BCPL
//    By Gordon Henderson, March 2023

GET "libhdr.h"
GET "sys.h"

LET nrlFloat () BE
{
  LET i, j = ?,?
  LET s = 0.0

  i := 1.0
  WHILE i #<= 10.0
  {
    s := 0.0
    j := 1.0
    WHILE j #<= 1000.0
    {
      s := s #+ j
      j := j #+ 1.0
    }

    wrch ('.')
    i := i #+ 1.0
  }

  writef ("%6n*n", FIX s)
}

LET nrlInt () BE
{
  LET s = 0 ;

  FOR i = 1 TO 10 DO
  {
    s := 0
    FOR j = 1 TO 1000 DO
      s := s + j
    wrch ('.')
  }

  writef ("%6n*n", s)
}

AND start () = VALOF
{
  LET tStart, tEnd = ?, ?

  tStart := sys (Sys_cputime)
    nrlFloat ()
  tEnd   := sys (Sys_cputime)
  writef ("  Float Time: %6.3d*n", tEnd - tStart)

  tStart := sys (Sys_cputime)
    nrlInt ()
  tEnd   := sys (Sys_cputime)
  writef ("Integer Time: %6.3d*n", tEnd - tStart)

  RESULTIS 0
}

