
// INTERFACE AGEs benchmark program to
// 'discover' the first 1000 Prime numbers
//	Re-coded in BCPL by me. Gordon Henderson

GET "libhdr.h"
GET "sys.h"

LET primeFP () BE
{
  LET n,k = ?,?
  LET m,l = ?,?

  n := 1.0
  WHILE n #<= 1000.0 DO
  {
    k := 2.0
    WHILE k #<= 500.0 DO
    {
      m := n #/ k
      l := FLOAT (FIX m)

      IF l #= 0.0 THEN GOTO line230
      IF l #= 1.0 THEN GOTO line220
      IF m #> l   THEN GOTO line220
      IF m #= l   THEN GOTO line240
line220:
      k := k #+ 1.0	// Next k
    }
line230:
    writef ("%4d", FIX n)
line240:
    n := n #+ 1.0		// Next n
  }
}

AND primeINT () BE
{
  LET isPrime = ?

  FOR n = 1 TO 1000 DO
  {
    isPrime := TRUE
    FOR k = 2 TO n / 2 DO
    {
      UNLESS (n MOD k) = 0 THEN	// Still potentially prime
	LOOP
      isPrime := FALSE
      BREAK
    }
    IF isPrime THEN
      writef ("%4d", n)
  }
}

AND try (fn, name) BE
{
  LET tStart, tEnd = ?,?

  writef ("Testing: %s*n", name)
  tStart := sys (Sys_cputime)
    fn ()
  tEnd   := sys (Sys_cputime)
  newline ()
  writef ("Time: %6.3d seconds*n", tEnd - tStart)
}

AND start () = VALOF
{
  try (primeFP,  "Floating Point")
  try (primeINT, "Integer")

  RESULTIS 0
}
